diff --git a/src/bin/pg_basebackup/pg_basebackup.c b/src/bin/pg_basebackup/pg_basebackup.c
index 851f03ca81..897f8982a2 100644
--- a/src/bin/pg_basebackup/pg_basebackup.c
+++ b/src/bin/pg_basebackup/pg_basebackup.c
@@ -966,6 +966,12 @@ parse_compress_options(char *src, WalCompressionMethod *methodres,
 	int			firstlen;
 	char	   *firstpart;
 
+	/*
+	 * clear 'levelres' so that if there are multiple compression options,
+	 * the last one fully overrides the earlier ones
+	 */
+	*levelres = 0;
+
 	/* check if the option is split in two */
 	sep = strchr(src, ':');
 
